/*
*  Program name:             arc_jkg  ver. 1.0
*
*  Program function:         Convert JKG file from ARC/INFO generate file
*
*  Programmed by:            Yasuaki MURATA,
*                            Geological Survey of Japan, Tsukuba
*                            Jan 11, 1993
*
*  Date of revision:         May 1, 2003 Distribution version by Y. Murata
*
*  Arguments:                None
*
*  Input:                    ARC/INFO generate file (from stdin)
*
*  Output:                   JKG format data (to stdout)
*/

#include <stdio.h>
#include <string.h>

main()
{
	long	n ;
	char	hed, txt[500] ;
	double	x, y ;

	while ((fgets(txt, 500, stdin)) != NULL) {
		if (strcmp(txt, "END") == 0) return(0) ;
		sscanf(txt, "%d", &n) ;
		hed = 'm' ;
		while ((fgets(txt, 500, stdin)) != NULL) {
			if (strcmp(txt, "END") == 0) break ;
			if (sscanf(txt, "%lf %lf", &x, &y) != 2) {
				fprintf(stderr, " ARC data error.\n") ;
				return(-1) ;
				}
			printf("%c %lf %lf\n", hed, x, y) ;
			hed = 'l' ;
			}
		}
	return(0) ;
	}
