/*
*  Program name:             dms  ver. 2.0
*
*  Program function:         JKG ==>> degree-minute-second routine
*
*  Programmed by:            Yasuaki MURATA,
*                            Geological Survey of Japan, Tsukuba
*                            November 4, 1992
*
*  Date of revision:         June 7, 1995  for JKG by Y.Murata
*                            May 1, 2003 Distribution version by Y. Murata
*
*  Input:                    JKG data from stdin (unit:second)
*                                 print only 'l','m','A' and 'W' data
*
*  Output:                   deg-min-sec to stdout
*/

#include <stdio.h>
#include <math.h>

main(argc, argv)
int	argc ;
char	*argv[] ;
{
	char	hed, txt[500] ;
	double	lon, lat, lon2, lat2, a3, o3 ;
	int	a1, a2, o1, o2 ;
	void	DMS() ;

	while ((fgets(txt, 500, stdin)) != NULL) {
	  if (txt[0] == 'l' || txt[0] == 'm') {
	    if (sscanf(txt, "%c %lf %lf", &hed, &lon, &lat) != 3) {
	      fprintf(stderr, " JKG l/m data error.\n") ;
	      break ;
	      }
	    DMS(&lat, &lon, &a1, &a2, &a3, &o1, &o2, &o3) ;
	    printf("%c %d^%d\'%lf\" %d^%d\'%lf\"\n",
	      hed, o1, o2, o3, a1, a2, a3) ;
	    }
	  else if(txt[0] == 'A' || txt[0] == 'W') {
	    if (sscanf(txt, "%c %lf %lf %lf %lf",
	      &hed, &lon, &lat, &lon2, &lat2) != 5) {
	      fprintf(stderr, " A/W data error.\n") ;
	      break ;
	      }
	    DMS(&lat, &lon, &a1, &a2, &a3, &o1, &o2, &o3) ;
	    printf("%c %d^%d\'%lf\" %d^%d\'%lf\" ",
	      hed, o1, o2, o3, a1, a2, a3) ;
	    DMS(&lat2, &lon2, &a1, &a2, &a3, &o1, &o2, &o3) ;
	    printf("%d^%d\'%lf\" %d^%d\'%lf\"\n",
	      o1, o2, o3, a1, a2, a3) ;
	    }
	  }
	return(0) ;
	}
/* -------------------------------------------------------------------------- */
void	DMS(lat, lon, a1, a2, a3, o1, o2, o3)
double	*lat, *lon, *a3, *o3 ;
int	*a1, *a2, *o1, *o2 ;
{
	*lat  = *lat ;
	*a1 = (int)(*lat / 3600.0) ;
	*a2 = (int)((*lat - (double)(*a1) * 3600.0) / 60.0) ;
	*a3 = *lat - (double)(*a1) * 3600.0 - (double)(*a2) * 60.0 ;
	*o1 = (int)(*lon / 3600.0) ;
	*o2 = (int)((*lon - (double)(*o1) * 3600.0) / 60.0) ;
	*o3 = *lon - (double)(*o1) * 3600.0 - (double)(*o2) * 60.0 ;
	}
