/*
*  Program name:             gener ver. 1.0
*
*  Program function:         generalize JKG data
*
*  Programmed by:            Yasuaki MURATA,
*                            Geological Survey of Japan, Tsukuba
*                            Nov 12, 1999
*
*  Date of revision:         May 1, 2003 Distribution version by Y. Murata
*
*  Arguments:                1. Generalizing width
*
*  Input:                    JKG data (from stdin)
*
*  Output:                   generalized JKG data (to stdout)
*/

#include <stdio.h>
#include <math.h>

#define	max(a, b)	(((a) > (b)) ? (a) : (b))
#define	min(a, b)	(((a) < (b)) ? (a) : (b))
#define	Nmax	1000

main(argc, argv)
int	argc ;
char	*argv[] ;
{
	char	hed, txt[500] ;
	int	i, np ;
	double	x[Nmax], y[Nmax], xk, yk, xl, yl, xj, yj ;
	double	xlk, ylk, xkj, ykj, denom, r, rmax ;
	double	t, xfac, yfac ;
	double	accy=1.0e-10 ;

	rmax = atof(argv[1]) ;
	rmax = rmax * rmax ;
	np = 0 ;
	while ( (fgets(txt, 500, stdin)) != NULL ) {
	  if (txt[0] == 'm') {
	    if (np > 1) printf("l %lf %lf\n", x[np-1], y[np-1]) ;
	    np = 1 ;
	    sscanf(txt, "%c %lf %lf", &hed, &x[0], &y[0]) ;
	    puts(txt) ;
	    }
	  else if (txt[0] == 'l') {
	    sscanf(txt, "%c %lf %lf", &hed, &x[np], &y[np]) ;
	    np++ ;
	    if (np > Nmax-1) {
	      printf("l %lf %lf\n", x[np-1], y[np-1]) ;
	      x[0] = x[np-1] ;
	      y[0] = y[np-1] ;
	      np = 1 ;
	      }
	    if (np > 2) {
	      xk = x[0] ;
	      yk = y[0] ;
	      xl = x[np-1] ;
	      yl = y[np-1] ;
	      xlk = xl - xk ;
	      ylk = yl - yk ;
	      denom = xlk * xlk + ylk * ylk ;
	      for (i = 1; i < np-1; i++) {
	        xj = x[i] ;
	        yj = y[i] ;
	        xkj = xk - xj ;
	        ykj = yk - yj ;
	        if (denom < accy) {
	          r = xkj * xkj + ykj * ykj ;
	          }
	        else {
	          t = -(xkj * xlk + ykj *ylk) / denom ;
	          t = min(max(t, 0.0), 1.0) ;
	          xfac = xkj + t * xlk ;
	          yfac = ykj + t * ylk ;
	          r = xfac * xfac + yfac * yfac ;
	          }
	        if (r > rmax) {
	          printf("l %lf %lf\n", x[np-2], y[np-2]) ;
	          x[0] = x[np-2] ;
	          y[0] = y[np-2] ;
	          x[1] = x[np-1] ;
	          y[1] = y[np-1] ;
	          np = 2 ;
	          }
	        }
	      }
	    }
	  else {
	    if (np > 1) printf("l %lf %lf\n", x[np-1], y[np-1]) ;
	    puts(txt) ;
	    x[0] = x[np-1] ;
	    y[0] = y[np-1] ;
	    np = 1 ;
	    }
	  }
	if (np > 1) printf("l %lf %lf\n", x[np-1], y[np-1]) ;
	return(0) ;
	}
