/*
*  Program name:             length ver. 1.0
*
*  Program function:         calculate total length of arcs
*
*  Programmed by:            Yasuaki MURATA,
*                            Geological Survey of Japan, Tsukuba
*                            July 27, 1994
*
*  Date of revision:         May 1, 2003 Distribution version by Y. Murata
*                            Sep 21. 2004 Add option (-a)
*
*  Arguments:                1. -a: show length of each arc
*
*  Input:                    JKG data from standard input (unit:second)
*                                 calculate only 'l' or 'm' data
*
*  Output:                   total length of arcs
*/

#include <stdio.h>

main(argc, argv)
int     argc ;
char    *argv[] ;
{
	int	arcs ;
	char	hed, txt[500] ;
	double	total1, total2, x, y, xo, yo, sqrt() ;
/* ---- argument read ---- */
	if (argc > 1 && strcmp(argv[1], "-a") == 0) arcs = 1 ; else arcs = 0 ;
/* ---- data read roop ---- */
	total1 = 0.0 ;
	while ( (fgets(txt, 500, stdin)) != NULL ) {
		if ( txt[0] == 'm' || txt[0] == 'l' ) {
			if ( (sscanf(txt, "%c %lf %lf", &hed, &x, &y)) != 3 ) {
				fprintf(stderr, " JKG data error %s", txt) ;
				printf("%s", txt) ;
				continue ;
				}
			if ( txt[0] == 'm' ) {
				if (arcs == 1) printf("Length of arcs = %lf / %lf\n", total2, total1) ;
				total2 = 0.0 ;
				}
			if ( txt[0] == 'l' ) {
				total1 = total1 + sqrt((x-xo)*(x-xo)+(y-yo)*(y-yo)) ;
				total2 = total2 + sqrt((x-xo)*(x-xo)+(y-yo)*(y-yo)) ;
				}
			xo = x ;
			yo = y ;
			}
		}
	if (arcs == 1) printf("Length of arcs = %lf / %lf\n", total2, total1) ;
	else printf("Total length of arcs = %lf\n", total1) ;
	return(0) ;
	}
